=== oqs-template/requirements.txt ===
Jinja2==3.1.4
MarkupSafe==2.1.3
PyYAML==6.0
tabulate==0.9.0
